/**
  *  \file client/widgets/configview.h
  *
  *  (c) 2001-2022 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_CLIENT_WIDGETS_CONFIGVIEW_H
#define PCC_V2_CLIENT_WIDGETS_CONFIGVIEW_H

#include <vector>
#include "util/conf.h"
#include "ui/listbox.h"

class WConfigView : public UIListbox {
 public:
    WConfigView(int id, int nlines, int width);
    ~WConfigView();

    void setHighlightSource(ConfigOption::Source level);
    void setNameColumnWidth(int widthInEms);

    void setContent(Config& cfg);
    void setContent(Config& cfg, string_t filter);

    void drawPart(GfxCanvas& can, int from, int to);

    ConfigOption* getCurrentOption();

 private:
    std::vector<ConfigOption*> data;
    ConfigOption::Source level;
    int nameColumnWidth;
};

#endif
